## ros-galactic-rcl-lifecycle 3.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl_lifecycle)

find_package(ament_cmake_ros REQUIRED)

find_package(lifecycle_msgs REQUIRED)
find_package(rcl REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(tracetools REQUIRED)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(
    -Wall -Wextra -Wpedantic
    -Wformat=2 -Wconversion -Wshadow -Wsign-conversion
  )
endif()

set(rcl_lifecycle_sources
  src/com_interface.c
  src/default_state_machine.c
  src/rcl_lifecycle.c
  src/transition_map.c
)
set_source_files_properties(
  ${rcl_lifecycle_sources}
  PROPERTIES language "C")

### C-Library depending only on RCL
add_library(
  ${PROJECT_NAME}
  ${rcl_lifecycle_sources})

target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")

# specific order: dependents before dependencies
ament_target_dependencies(rcl_lifecycle
  "lifecycle_msgs"
  "rcl"
  "rcutils"
  "rosidl_runtime_c"
  "tracetools"
)

rcl_set_symbol_visibility_hidden(${PROJECT_NAME} LANGUAGE "C")
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rcl_lifecycle PRIVATE "RCL_LIFECYCLE_BUILDING_DLL")

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

install(TARGETS rcl_lifecycle EXPORT rcl_lifecycle
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(rcl REQUIRED)
  find_package(osrf_testing_tools_cpp REQUIRED)
  ament_lint_auto_find_test_dependencies()

  # Gtests
  ament_add_gtest(test_default_state_machine
    test/test_default_state_machine.cpp
  )
  if(TARGET test_default_state_machine)
    ament_target_dependencies(test_default_state_machine
      "rcl"
      "osrf_testing_tools_cpp"
    )
    target_link_libraries(test_default_state_machine ${PROJECT_NAME})
    target_compile_definitions(test_default_state_machine
      PUBLIC RCUTILS_ENABLE_FAULT_INJECTION
    )
  endif()
  ament_add_gtest(test_multiple_instances
    test/test_multiple_instances.cpp
  )
  if(TARGET test_multiple_instances)
    ament_target_dependencies(test_multiple_instances
      "rcl"
      "osrf_testing_tools_cpp"
    )
    target_link_libraries(test_multiple_instances ${PROJECT_NAME})
  endif()
  ament_add_gtest(test_rcl_lifecycle
    test/test_rcl_lifecycle.cpp
  )
  if(TARGET test_rcl_lifecycle)
    ament_target_dependencies(test_rcl_lifecycle
      "rcl"
      "osrf_testing_tools_cpp"
    )
    target_link_libraries(test_rcl_lifecycle ${PROJECT_NAME})
    target_compile_definitions(test_rcl_lifecycle
      PUBLIC RCUTILS_ENABLE_FAULT_INJECTION
    )
  endif()
  ament_add_gtest(test_transition_map
    test/test_transition_map.cpp
  )
  if(TARGET test_transition_map)
    ament_target_dependencies(test_transition_map
      "rcl"
    )
    target_link_libraries(test_transition_map ${PROJECT_NAME})
  endif()
endif()

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})
ament_export_dependencies(ament_cmake)
ament_export_dependencies(lifecycle_msgs)
ament_export_dependencies(rcl)
ament_export_dependencies(rcutils)
ament_export_dependencies(rosidl_runtime_c)
ament_export_dependencies(tracetools)
ament_package()

install(
  DIRECTORY include/
  DESTINATION include)

=== debian/changelog ===
ros-galactic-rcl-lifecycle (3.1.4-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 02 Dec 2022 08:00:00 -0000

ros-galactic-rcl-lifecycle (3.1.3-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 28 Apr 2022 07:00:00 -0000

ros-galactic-rcl-lifecycle (3.1.2-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 26 Apr 2021 07:00:00 -0000

ros-galactic-rcl-lifecycle (3.1.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 12 Apr 2021 07:00:00 -0000

ros-galactic-rcl-lifecycle (3.1.0-1focal) focal; urgency=high

  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#909 <https://github.com/ros2/rcl/issues/909>)
  * Contributors: shonigmann

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 06 Apr 2021 07:00:00 -0000

ros-galactic-rcl-lifecycle (3.0.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 25 Mar 2021 07:00:00 -0000

ros-galactic-rcl-lifecycle (3.0.0-1focal) focal; urgency=high

  * make rcl_lifecycle_com_interface optional in lifecycle nodes (#882 <https://github.com/ros2/rcl/issues/882>)
  * Contributors: Karsten Knese

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 23 Mar 2021 07:00:00 -0000

ros-galactic-rcl-lifecycle (2.6.0-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Thu, 18 Mar 2021 07:00:00 -0000

ros-galactic-rcl-lifecycle (2.5.2-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Fri, 05 Feb 2021 08:00:00 -0000

ros-galactic-rcl-lifecycle (2.5.1-1focal) focal; urgency=high



 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 25 Jan 2021 08:00:00 -0000

ros-galactic-rcl-lifecycle (2.5.0-1focal) focal; urgency=high

  * Update QDs to QL 1 (#866 <https://github.com/ros2/rcl/issues/866>)
  * Update QL (#858 <https://github.com/ros2/rcl/issues/858>)
  * Make sure to always check return values (#840 <https://github.com/ros2/rcl/issues/840>)
  * Update tracetools QL and add to rcl_lifecycle's QD (#845 <https://github.com/ros2/rcl/issues/845>)
  * Add compiler warnings (#830 <https://github.com/ros2/rcl/issues/830>)
  * Contributors: Alejandro Hernández Cordero, Audrow Nash, Chris Lalancette, Christophe Bedard, Stephen Brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Tue, 08 Dec 2020 08:00:00 -0000

ros-galactic-rcl-lifecycle (2.4.0-1focal) focal; urgency=high

  * Make sure to check the return value of rcl APIs. (#838 <https://github.com/ros2/rcl/issues/838>)
  * Contributors: Chris Lalancette

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 19 Oct 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (2.3.0-1focal) focal; urgency=high

  * Add lifecycle node state transition instrumentation (#804 <https://github.com/ros2/rcl/issues/804>)
  * Update maintainers (#825 <https://github.com/ros2/rcl/issues/825>)
  * Improve error messages in rcl_lifecycle (#742 <https://github.com/ros2/rcl/issues/742>)
  * Fix test_rcl_lifecycle (#788 <https://github.com/ros2/rcl/issues/788>)
  * Contributors: Christophe Bedard, Ivan Santiago Paunovic, Lei Liu, brawner

 -- Ivan Paunovic <ivanpauno@ekumenlabs.com>  Mon, 19 Oct 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (2.2.0-1focal) focal; urgency=high

  * Add fault injection macros and unit tests to rcl_lifecycle (#731 <https://github.com/ros2/rcl/issues/731>)
  * Remove std::cout line from test_rcl_lifecycle.cpp (#773 <https://github.com/ros2/rcl/issues/773>)
  * Set transition_map->states/transition size to 0 on fini (#729 <https://github.com/ros2/rcl/issues/729>)
  * Contributors: brawner

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 02 Sep 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (2.1.0-1focal) focal; urgency=high

  * Topic fix rcl lifecycle test issue (#715 <https://github.com/ros2/rcl/issues/715>)
  * Removed doxygen warnings (#712 <https://github.com/ros2/rcl/issues/712>)
  * Contributors: Alejandro Hernández Cordero, Barry Xu

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 22 Jul 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (2.0.0-1focal) focal; urgency=high

  * Update quality declaration and coverage (#674 <https://github.com/ros2/rcl/issues/674>)
  * Contributors: Alejandro Hernández Cordero

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 09 Jul 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (1.2.0-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 18 Jun 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (1.1.5-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 03 Jun 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (1.1.4-1focal) focal; urgency=high



 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 02 Jun 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (1.1.3-1focal) focal; urgency=high

  * Add Security Vulnerability Policy pointing to REP-2006 (#661 <https://github.com/ros2/rcl/issues/661>)
  * Contributors: Chris Lalancette

 -- Karsten Knese <karsten@osrfoundation.org>  Mon, 01 Jun 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (1.1.2-1focal) focal; urgency=high

  * Allow transition start and goal states to be null (#662 <https://github.com/ros2/rcl/issues/662>)
  * Contributors: Karsten Knese

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 28 May 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (1.1.1-1focal) focal; urgency=high

  * Increase rcl_lifecycle test coverage and add more safety checks (#649 <https://github.com/ros2/rcl/issues/649>)
  * Contributors: Stephen Brawner

 -- Karsten Knese <karsten@osrfoundation.org>  Tue, 26 May 2020 07:00:00 -0000

ros-galactic-rcl-lifecycle (1.1.0-1focal) focal; urgency=high

  * Update Quality Declaration for 1.0 (#647 <https://github.com/ros2/rcl/issues/647>)
  * Contributors: brawner

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 22 May 2020 07:00:00 -0000



=== debian/control ===
Source: ros-galactic-rcl-lifecycle
Section: misc
Priority: optional
Maintainer: Ivan Paunovic <ivanpauno@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake-gtest <!nocheck>, ros-galactic-ament-cmake-ros, ros-galactic-ament-lint-auto <!nocheck>, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-lifecycle-msgs, ros-galactic-osrf-testing-tools-cpp <!nocheck>, ros-galactic-rcl, ros-galactic-rcutils, ros-galactic-rmw, ros-galactic-rosidl-runtime-c, ros-galactic-tracetools, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rcl-lifecycle
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-lifecycle-msgs, ros-galactic-rcl, ros-galactic-rcutils, ros-galactic-rmw, ros-galactic-rosidl-runtime-c, ros-galactic-tracetools, ros-galactic-ros-workspace
Description: Package containing a C-based lifecycle implementation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-rcl-lifecycle//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
